Lattice Grid Buy a licence

demo D128

Formula entry

A spreadsheet formula typed into a cell, and the evaluator reach limit

formulaFunctions

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const columns = [
  { field: 'description', title: 'Description', layout: { flex: 1, min: 160, pin: 'start' } },
  { field: 'quantity', title: 'Qty', type: 'number', edit: true, layout: { width: 100 } },
  { field: 'unitPrice', title: 'Unit price', type: 'number', edit: true,
    format: { style: 'currency', currency: 'GBP' }, layout: { width: 140 } },
  { field: 'discount', title: 'Discount', type: 'number', edit: true,
    format: { style: 'percent', decimals: 0 }, layout: { width: 140 } },
  { id: 'lineNet', title: 'Line net', type: 'number',
    format: { style: 'currency', currency: 'GBP' }, layout: { width: 130 },
    value: {
      deps: ['quantity', 'unitPrice', 'discount'],
      compute: (d) => d.quantity * d.unitPrice * (1 - d.discount),
    } },
  { field: 'total', title: 'Total', type: 'number',
    format: { style: 'currency', currency: 'GBP' },
    layout: { width: 140, pin: 'end' }, total: 'sum',
    // The total column takes a typed formula such as
    // =ROUND(quantity * unitPrice * (1 - discount), 2), drawing on the built-in
    // function library. The formula path lives in the number type's parse,
    // which only sees what the editor produces, so a column that accepts
    // formulas asks for the text editor here; the default number editor would
    // hand back a plain number and the formula would never reach the evaluator.
    edit: { enabled: true, editor: 'text' } },
];

const rows = [/* invoice lines: description, quantity, unitPrice, discount, total (empty) */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'id',
    edit: true,
    selection: 'multiple',
    columns: columns,
    rows: rows,
  };
}

bootstrapApplication(AppComponent);

Typing a spreadsheet formula into a cell

Formula entry lets a cell hold =SUM(B2:B8) or =A3*1.2 instead of a static value, and the grid parses, evaluates, and re-evaluates it as the referenced cells change. A developer reaches for it wherever a grid stands in for a spreadsheet a user already expects to type into: budget lines, pricing sheets, a reconciliation view where a total needs to track its inputs rather than be pasted in by hand. Lattice Grid registers the supported operators and functions through formulaFunctions, so a column can expose only SUM, AVERAGE, and a handful of arithmetic operators, or a wider set, without the evaluator accepting an unbounded expression language. Entry works like inline editing: a formula is typed directly into the cell, committed with Enter, and re-parsed each time a dependency’s value is written. Lattice Grid tracks a bounded evaluator reach, so a formula referencing thousands of cells fails predictably at the configured limit rather than recursing until the tab stalls, which matters for a JavaScript data grid rendering tens of thousands of rows where a runaway calculation would otherwise block the main thread. A screen reader announces the evaluated result, not the formula text, so a non-sighted user hears the number a sighted user sees, with the formula itself available on request when the cell is focused for editing.

How do I add spreadsheet formulas to a grid cell?

Configure the column’s formulaFunctions with the operators and functions a formula is allowed to call, then enter a formula in a cell starting with =. Lattice Grid parses it, evaluates it against the referenced cells, and re-evaluates it whenever those cells change. An evaluator reach limit caps how many dependencies a single formula can walk, so a malformed or excessive reference fails at that boundary rather than degrading performance across the grid.

Lattice Grid Buy a licence

demo D128

Formula entry

A spreadsheet formula typed into a cell, and the evaluator reach limit

formulaFunctions

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'description', title: 'Description', layout: { flex: 1, min: 160, pin: 'start' } },
    { field: 'quantity', title: 'Qty', type: 'number', edit: true, layout: { width: 100 } },
    { field: 'unitPrice', title: 'Unit price', type: 'number', edit: true,
      format: { style: 'currency', currency: 'GBP' }, layout: { width: 140 } },
    { field: 'discount', title: 'Discount', type: 'number', edit: true,
      format: { style: 'percent', decimals: 0 }, layout: { width: 140 } },
    { id: 'lineNet', title: 'Line net', type: 'number',
      format: { style: 'currency', currency: 'GBP' }, layout: { width: 130 },
      value: {
        deps: ['quantity', 'unitPrice', 'discount'],
        compute: (d) => d.quantity * d.unitPrice * (1 - d.discount),
      } },
    { field: 'total', title: 'Total', type: 'number',
      format: { style: 'currency', currency: 'GBP' },
      layout: { width: 140, pin: 'end' }, total: 'sum',
      // The total column takes a typed formula such as
      // =ROUND(quantity * unitPrice * (1 - discount), 2), drawing on the built-in
      // function library. The formula path lives in the number type's parse,
      // which only sees what the editor produces, so a column that accepts
      // formulas asks for the text editor here; the default number editor would
      // hand back a plain number and the formula would never reach the evaluator.
      edit: { enabled: true, editor: 'text' } },
  ];

  const rows = [/* invoice lines: description, quantity, unitPrice, discount, total (empty) */];

  function App() {
    return (
      <LatticeGrid
        rowKey="id"
        edit
        selection="multiple"
        columns={columns}
        rows={rows}
        style={{ height: '540px' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Typing a spreadsheet formula into a cell

Formula entry lets a cell hold =SUM(B2:B8) or =A3*1.2 instead of a static value, and the grid parses, evaluates, and re-evaluates it as the referenced cells change. A developer reaches for it wherever a grid stands in for a spreadsheet a user already expects to type into: budget lines, pricing sheets, a reconciliation view where a total needs to track its inputs rather than be pasted in by hand. Lattice Grid registers the supported operators and functions through formulaFunctions, so a column can expose only SUM, AVERAGE, and a handful of arithmetic operators, or a wider set, without the evaluator accepting an unbounded expression language. Entry works like inline editing: a formula is typed directly into the cell, committed with Enter, and re-parsed each time a dependency’s value is written. Lattice Grid tracks a bounded evaluator reach, so a formula referencing thousands of cells fails predictably at the configured limit rather than recursing until the tab stalls, which matters for a JavaScript data grid rendering tens of thousands of rows where a runaway calculation would otherwise block the main thread. A screen reader announces the evaluated result, not the formula text, so a non-sighted user hears the number a sighted user sees, with the formula itself available on request when the cell is focused for editing.

How do I add spreadsheet formulas to a grid cell?

Configure the column’s formulaFunctions with the operators and functions a formula is allowed to call, then enter a formula in a cell starting with =. Lattice Grid parses it, evaluates it against the referenced cells, and re-evaluates it whenever those cells change. An evaluator reach limit caps how many dependencies a single formula can walk, so a malformed or excessive reference fails at that boundary rather than degrading performance across the grid.